]> git.pld-linux.org Git - packages/rpm-build-tools.git/blame - builder.sh
- use cvsup() also when fetching spec
[packages/rpm-build-tools.git] / builder.sh
CommitLineData
cd445739
AM
1#!/bin/sh
2# -----------
3# $Id$
4# Exit codes:
2a5f078d 5# 0 - succesful
6# 1 - help displayed
7# 2 - no spec file name in cmdl parameters
8# 3 - spec file not stored in repo
9# 4 - some source, patch or icon files not stored in repo
10# 5 - package build failed
11# 6 - spec file with errors
12# 7 - wrong source in /etc/poldek.conf
13# 8 - Failed installing buildrequirements and subrequirements
14# 9 - Requested tag already exist
15# 10 - Refused to build fractional release
16# 100 - Unknown error (should not happen)
cd445739
AM
17
18# Notes (todo):
f7b91886 19# - builder -u fetches current version first (well that's okay, how you compare versions if you have no old spec?)
cd445739 20# - when Icon: field is present, -5 and -a5 doesn't work
f3ada241 21# - builder -R skips installing BR if spec is not present before builder invocation (need to run builder twice)
931a4acf 22
4003ad8c 23VERSION="\
c9acaed9 24Build package utility from PLD Linux CVS repository
7304d35c 25V 0.13 (C) 1999-2005 Free Penguins".
d6a77ddb 26PATH="/bin:/usr/bin:/usr/sbin:/sbin:/usr/X11R6/bin"
b03f053b 27
cd445739 28COMMAND="build"
64ea5308 29TARGET=""
cd445739 30
bde1c404 31SPECFILE=""
d287305c 32BE_VERBOSE=""
4003ad8c 33QUIET=""
cd445739
AM
34CLEAN=""
35DEBUG=""
36NOURLS=""
37NOCVS=""
38NOCVSSPEC=""
39NODIST=""
40UPDATE=""
41UPDATE5=""
42ADD5=""
43NO5=""
44ALWAYS_CVSUP=${ALWAYS_CVSUP:-"yes"}
c8f50498 45CVSROOT=""
cd445739
AM
46
47# It can be used i.e. in log file naming.
48# See LOGFILE example.
49DATE=`date +%Y-%m-%d_%H-%M-%S`
50
51# Example: LOGFILE='../log.$PACKAGE_NAME'
52# Example: LOGFILE='../LOGS/log.$PACKAGE_NAME.$DATE'
53# Yes, you can use variable name! Note _single_ quotes!
54LOGFILE=''
55
56LOGDIR=""
57LOGDIROK=""
58LOGDIRFAIL=""
59LASTLOG_FILE=""
60
61CHMOD="no"
62CHMOD_MODE="0444"
63RPMOPTS=""
64BCOND=""
65GROUP_BCONDS="no"
947025e5 66CVSIGNORE_DF="no"
d287305c 67
68PATCHES=""
69SOURCES=""
cd445739 70ICONS=""
d287305c 71PACKAGE_RELEASE=""
72PACKAGE_VERSION=""
73PACKAGE_NAME=""
cd445739
AM
74PROTOCOL="ftp"
75WGET_RETRIES=${MAX_WGET_RETRIES:-0}
76CVS_RETRIES=${MAX_CVS_RETRIES:-1000}
77
78CVSTAG=""
79RES_FILE=""
80
81CVS_SERVER="cvs.pld-linux.org"
82DISTFILES_SERVER="://distfiles.pld-linux.org"
d4730dae 83ATTICDISTFILES_SERVER="://attic-distfiles.pld-linux.org"
cd445739 84
36d03934 85DEF_NICE_LEVEL=19
cd445739
AM
86
87FAIL_IF_NO_SOURCES="yes"
88
18e5347d
ER
89# let get_files skip over files which are present to get those damn files fetched
90SKIP_EXISTING_FILES="no"
91
ab4a2b6e
ER
92if [ -x /usr/bin/rpm-getdeps ]; then
93 FETCH_BUILD_REQUIRES_RPMGETDEPS="yes"
94else
95 FETCH_BUILD_REQUIRES_RPMGETDEPS="no"
96fi
97
cd445739
AM
98# Here we load saved user environment used to
99# predefine options set above, or passed to builder
100# in command line.
101# This one reads global system environment settings:
102if [ -f ~/etc/builderrc ]; then
103 . ~/etc/builderrc
104fi
105# And this one cascades settings using user personal
106# builder settings.
107# Example of ~/.builderrc:
108#
109#UPDATE_POLDEK_INDEXES="yes"
110#FETCH_BUILD_REQUIRES="yes"
111#REMOVE_BUILD_REQUIRES="force"
112#GROUP_BCONDS="yes"
113#LOGFILE='../LOGS/log.$PACKAGE_NAME.$DATE'
114#
a83e5405 115SU_SUDO=""
cd445739
AM
116if [ -n "$HOME_ETC" ]; then
117 USER_CFG="$HOME_ETC/.builderrc"
118else
119 USER_CFG=~/.builderrc
120fi
121
122[ -f "$USER_CFG" ] && . "$USER_CFG"
123
06f3864d
AM
124wget --help 2>&1 | grep -q ' \-\-no-check\-certificate ' && WGET_OPTS="$WGET_OPTS --no-check-certificate"
125
ca2e6c31 126if [ -n "$USE_PROZILLA" ]; then
7e365483
KK
127 GETURI="proz --no-getch -r -P ./ -t$WGET_RETRIES $PROZILLA_OPTS"
128 GETURI2="$GETURI"
129 OUTFILEOPT="-O"
ca2e6c31 130elif [ -n "$USE_AXEL" ]; then
cede92b3 131 GETURI="axel -a $AXEL_OPTS"
7e365483
KK
132 GETURI2="$GETURI"
133 OUTFILEOPT="-o"
ca2e6c31 134else
7e365483
KK
135 wget --help 2>&1 | grep -q ' \-\-inet ' && WGET_OPTS="$WGET_OPTS --inet"
136 wget --help 2>&1 | grep -q ' \-\-retry\-connrefused ' && WGET_OPTS="$WGET_OPTS --retry-connrefused"
6f9a5d76 137
7e365483
KK
138 GETURI="wget --passive-ftp -c -nd -t$WGET_RETRIES $WGET_OPTS"
139 GETURI2="wget -c -nd -t$WGET_RETRIES $WGET_OPTS"
140 OUTFILEOPT="-O"
2bc5451f 141fi
11468b23 142
11468b23
AM
143GETLOCAL="cp -a"
144
145if (rpm --version 2>&1 | grep -q '4.0.[0-2]'); then
146 RPM="rpm"
147 RPMBUILD="rpm"
148else
149 RPM="rpm"
150 RPMBUILD="rpmbuild"
151fi
152
153POLDEK_INDEX_DIR="`$RPM --eval %_rpmdir`/"
a83e5405 154POLDEK_CMD="$SU_SUDO /usr/bin/poldek --noask"
11468b23 155
cd445739
AM
156run_poldek()
157{
158 RES_FILE=~/tmp/poldek-exit-status.$RANDOM
159 if [ -n "$LOGFILE" ]; then
160 LOG=`eval echo $LOGFILE`
161 if [ -n "$LASTLOG_FILE" ]; then
162 echo "LASTLOG=$LOG" > $LASTLOG_FILE
163 fi
040282bb 164 (nice -n ${DEF_NICE_LEVEL} ${POLDEK_CMD} `while test $# -gt 0; do echo "$1 ";shift;done` ; echo $? > ${RES_FILE})|tee -a $LOG
cd445739
AM
165 return $exit_pldk
166 else
167 (nice -n ${DEF_NICE_LEVEL} ${POLDEK_CMD} `while test $# -gt 0; do echo "$1 ";shift;done` ; echo $? > ${RES_FILE}) 1>&2 >/dev/null
168 return `cat ${RES_FILE}`
169 rm -rf ${RES_FILE}
170 fi
171}
172
cd445739
AM
173#---------------------------------------------
174# functions
da946cd6 175
5a491465 176usage()
177{
cd445739
AM
178 if [ -n "$DEBUG" ]; then set -xv; fi
179 echo "\
180Usage: builder [-D|--debug] [-V|--version] [-a|--as_anon] [-b|-ba|--build]
81f85806 181
cd445739
AM
182[-bb|--build-binary] [-bs|--build-source] [-u|--try-upgrade]
183[{-B|--branch} <branch>] [{-d|--cvsroot} <cvsroot>] [-g|--get]
184[-h|--help] [--http] [{-l,--logtofile} <logfile>] [-m|--mr-proper]
185[-q|--quiet] [--date <yyyy-mm-dd> [-r <cvstag>] [{-T--tag <cvstag>]
186[-Tvs|--tag-version-stable] [-Tvn|--tag-version-nest]
187[-Ts|--tag-stable] [-Tn|--tag-nest] [-Tv|--tag-version]
188[{-Tp|--tag-prefix} <prefix>] [{-tt|--test-tag}]
dfe2cb9a 189[-nu|--no-urls] [-v|--verbose] [--opts <rpm opts>] [--show-bconds]
cd445739 190[--with/--without <feature>] [--define <macro> <value>] <package>[.spec]
2a5f078d 191
cd445739
AM
192-5, --update-md5 - update md5 comments in spec, implies -nd -ncs
193-a5, --add-md5 - add md5 comments to URL sources, implies -nc -nd -ncs
194-n5, --no-md5 - ignore md5 comments in spec
9243e80b
ER
195-D, --debug - enable builder script debugging mode,
196-debug - produce rpm debug package (same as --opts -debug)
cd445739
AM
197-V, --version - output builder version
198-a, --as_anon - get files via pserver as cvs@$CVS_SERVER,
199-b, -ba, --build - get all files from CVS repo or HTTP/FTP and build package
200 from <package>.spec,
201-bb, --build-binary - get all files from CVS repo or HTTP/FTP and build binary
202 only package from <package>.spec,
c56807e0
ER
203-bp, --build-prep - execute the %prep phase of <package>.spec,
204-bc - reserved (not implemented)
205-bi reserved (not implemented)
cd445739
AM
206-bs, --build-source - get all files from CVS repo or HTTP/FTP and only pack
207 them into src.rpm,
c56807e0 208--short-circuit - reserved (not implemented)
cd445739
AM
209-B, --branch - add branch
210-c, --clean - clean all temporarily created files (in BUILD, SOURCES,
211 SPECS and \$RPM_BUILD_ROOT),
2a5f078d 212-d <cvsroot>, --cvsroot <cvsroot>
cd445739
AM
213 - setup \$CVSROOT,
214--define <macro> <value>
215 - define a macro <macro> with value <value>,
216--nodeps - rpm won't check any dependences
217-g, --get - get <package>.spec and all related files from CVS repo
218 or HTTP/FTP,
219-h, --help - this message,
220--http - use http instead of ftp,
221-l <logfile>, --logtofile <logfile>
222 - log all to file,
223-m, --mr-proper - only remove all files related to spec file and all work
224 resources,
225-nc, --no-cvs - don't download sources from CVS, if source URL is given,
226-ncs, --no-cvs-specs
227 - don't check specs in CVS
228-nd, --no-distfiles - don't download from distfiles
229-nm, --no-mirrors - don't download from mirror, if source URL is given,
230-nu, --no-urls - don't try to download from FTP/HTTP location,
231-ns, --no-srcs - don't download Sources
232-ns0, --no-source0 - don't download Source0
233-nn, --no-net - don't download anything from the net
18e5347d
ER
234-ske,
235--skip-existing-files - skip existing files in get_files
cd445739
AM
236--opts <rpm opts> - additional options for rpm
237-q, --quiet - be quiet,
238--date yyyy-mm-dd - build package using resources from specified CVS date,
239-r <cvstag>, --cvstag <cvstag>
240 - build package using resources from specified CVS tag,
241-R, --fetch-build-requires
242 - fetch what is BuildRequired,
243-RB, --remove-build-requires
244 - remove all you fetched with -R or --fetch-build-requires
245 remember, this option requires confirmation,
246-FRB, --force-remove-build-requires
247 - remove all you fetched with -R or --fetch-build-requires
248 remember, this option works without confirmation,
a7eefc54 249-sf, --source-files - list sources - bare filenames (intended for offline
250 operations; does not work when Icon field is present
251 but icon file is absent),
252-sp, --source-paths - list sources - filenames with full local paths (intended for
253 offline operations; does not work when Icon field is present
254 but icon file is absent),
2dddf439
ER
255-su, --source-urls - list urls - urls to sources and patches
256 intended for copying urls with spec with lots of macros in urls
cd445739
AM
257-T <cvstag> , --tag <cvstag>
258 - add cvs tag <cvstag> for files,
259-Tvs, --tag-version-stable
094bd95b 260 - add cvs tags STABLE and NAME-VERSION-RELEASE for files,
cd445739 261-Tvn, --tag-version-nest
1691a37b 262 - add cvs tags NEST and NAME-VERSION-RELEASE for files,
cd445739
AM
263-Ts, --tag-stable
264 - add cvs tag STABLE for files,
265-Tn, --tag-nest
266 - add cvs tag NEST for files,
267-Tv, --tag-version
1691a37b 268 - add cvs tag NAME-VERSION-RELEASE for files,
cd445739
AM
269-Tp, --tag-prefix <prefix>
270 - add <prefix> to NAME-VERSION-RELEASE tags,
271-tt, --test-tag <prefix>
272 - fail if tag is already present,
50321881
JK
273-ir, --integer-release-only
274 - allow only integer and snapshot releases
cd445739
AM
275-v, --verbose - be verbose,
276-u, --try-upgrade - check version, and try to upgrade package
277-un, --try-upgrade-with-float-version
278 - as above, but allow float version
deccc50e 279-U, --update - refetch sources, don't use distfiles, and update md5 comments
cd445739
AM
280-Upi, --update-poldek-indexes
281 - refresh or make poldek package index files.
c890b916 282-np, --nopatch <patchnumber>
bed98670 283 - don't apply <patchnumber>
dfe2cb9a
MK
284--show-bconds - show available conditional builds, which can be used
285 - with --with and/or --without switches.
cd445739
AM
286--with/--without <feature>
287 - conditional build package depending on %_with_<feature>/
288 %_without_<feature> macro switch. You may now use
289 --with feat1 feat2 feat3 --without feat4 feat5 --with feat6
290 constructions. Set GROUP_BCONDS to yes to make use of it.
6dd19291 291--target <platform>, --target=<platform>
64ea5308 292 - build for platform <platform>.
5a491465 293"
294}
295
c890b916 296update_shell_title() {
a0d6396b 297 [ -t 1 ] || return
0b65d15e
ER
298 local len=${COLUMNS:-80}
299 local msg=$(echo "$*" | cut -c-$len)
300
f2e42a41 301 msg="builder[$SPECFILE] ${SHELL_TITLE_PREFIX:+$SHELL_TITLE_PREFIX }$msg"
c890b916
ER
302 case "$TERM" in
303 cygwin|xterm*)
2dddf439 304 echo >&2 -ne "\033]1;$msg\007\033]2;$msg\007"
c890b916
ER
305 ;;
306 screen*)
2dddf439 307 echo >&2 -ne "\033]0;$msg\007"
c890b916
ER
308 ;;
309 esac
310}
311
7e40520f
ER
312# set TARGET from BuildArch: from SPECFILE
313set_spec_target() {
314 if [ -n "$SPECFILE" ] && [ -z "$TARGET" ]; then
315 tmp=$(awk '/^BuildArch:/ { print $NF}' $SPECFILE)
316 if [ "$tmp" ]; then
317 TARGET="$tmp"
318 case "$RPMBUILD" in
319 "rpmbuild")
320 TARGET_SWITCH="--target $TARGET" ;;
321 "rpm")
322 TARGET_SWITCH="--target=$TARGET" ;;
323 esac
324 fi
325 fi
326}
327
cd445739 328cache_rpm_dump () {
b2aeec7d
AM
329 if [ -n "$DEBUG" ]; then
330 set -x;
331 set -v;
332 fi
7e40520f 333
cd445739
AM
334rpm_dump_cache=`
335 case "$RPMBUILD" in
336 rpm )
2a5f078d 337 rpm -bp --nodeps --define 'prep %dump' $BCOND $TARGET_SWITCH $SPECFILE 2>&1
cd445739
AM
338 ;;
339 rpmbuild )
2f810e46 340 rpmbuild --nodigest --nosignature --define 'prep %dump' $BCOND $TARGET_SWITCH $SPECFILE 2>&1
cd445739
AM
341 ;;
342 esac`
343}
344
345rpm_dump () {
346 if [ -z "$rpm_dump_cache" ] ; then
347 echo "internal error: cache_rpm_dump not called!" 1>&2
348 fi
349 echo "$rpm_dump_cache"
350}
351
59398507 352parse_spec()
353{
af4d5315 354 update_shell_title "parsing specfile"
cd445739
AM
355 if [ -n "$DEBUG" ]; then
356 set -x;
357 set -v;
358 fi
b2975fc3 359
cd445739 360 cd $SPECS_DIR
4ca52257 361
cd445739 362 cache_rpm_dump
00fcec7e 363
cd445739
AM
364 if [ "$NOSRCS" != "yes" ]; then
365 SOURCES="`rpm_dump | awk '/SOURCEURL[0-9]+/ {print $3}'`"
366 fi
367 if (rpm_dump | grep -qEi ":.*nosource.*1"); then
368 FAIL_IF_NO_SOURCES="no"
369 fi
370
371 PATCHES="`rpm_dump | awk '/PATCHURL[0-9]+/ {print $3}'`"
372 ICONS="`awk '/^Icon:/ {print $2}' ${SPECFILE}`"
373 PACKAGE_NAME="`$RPM -q --qf '%{NAME}\n' --specfile ${SPECFILE} 2> /dev/null | head -n 1`"
374 PACKAGE_VERSION="`$RPM -q --qf '%{VERSION}\n' --specfile ${SPECFILE} 2> /dev/null| head -n 1`"
375 PACKAGE_RELEASE="`$RPM -q --qf '%{RELEASE}\n' --specfile ${SPECFILE} 2> /dev/null | head -n 1`"
376
341603cf 377# These variables may be unset after first cache_rpm_dump call
378# (because of not-yet-retrieved icon file)
379#
380# if [ -z "$PACKAGE_NAME" -o -z "$PACKAGE_VERSION" -o -z "$PACKAGE_RELEASE" ]; then
381# Exit_error err_no_package_data;
382# fi
78eab2a1 383
cd445739
AM
384 if [ -n "$BE_VERBOSE" ]; then
385 echo "- Sources : `nourl $SOURCES`"
386 if [ -n "$PATCHES" ]; then
387 echo "- Patches : `nourl $PATCHES`"
388 else
389 echo "- Patches : *no patches needed*"
390 fi
391 if [ -n "$ICONS" ]; then
392 echo "- Icon : `nourl $ICONS`"
393 else
394 echo "- Icon : *no package icon*"
395 fi
396 echo "- Name : $PACKAGE_NAME"
397 echo "- Version : $PACKAGE_VERSION"
398 echo "- Release : $PACKAGE_RELEASE"
399 fi
400}
401
402Exit_error()
403{
404 if [ -n "$DEBUG" ]; then
405 set -x;
406 set -v;
407 fi
408
409 cd "$__PWD"
410
411 case "$1" in
412 "err_no_spec_in_cmdl" )
413 remove_build_requires
414 echo "ERROR: spec file name not specified.";
415 exit 2 ;;
416 "err_no_spec_in_repo" )
417 remove_build_requires
418 echo "Error: spec file not stored in CVS repo.";
419 exit 3 ;;
420 "err_no_source_in_repo" )
421 remove_build_requires
422 echo "Error: some source, patch or icon files not stored in CVS repo. ($2)";
423 exit 4 ;;
424 "err_build_fail" )
425 remove_build_requires
426 echo "Error: package build failed. (${2:-no more info})";
427 exit 5 ;;
78eab2a1
AM
428 "err_no_package_data" )
429 remove_build_requires
430 echo "Error: couldn't get out package name/version/release from spec file."
431 exit 6 ;;
50321881
JK
432 "err_tag_exists" )
433 remove_build_requires
434 echo "Tag ${2} already exists (spec release: ${3}).";
435 exit 9 ;;
436 "err_fract_rel" )
437 remove_build_requires
438 echo "Release ${2} not integer and not a snapshot.";
439 exit 10 ;;
fb96e0b5
AM
440 "err_branch_exists" )
441 remove_build_requires
442 echo "Tree branch already exists (${2}).";
443 exit 11 ;;
50321881 444
cd445739 445 esac
50321881 446 echo "Unknown error."
2a5f078d 447 exit 100
cd445739
AM
448}
449
450init_builder()
451{
452 if [ -n "$DEBUG" ]; then
453 set -x;
454 set -v;
0dd6320d 455 fi
cd445739
AM
456
457 SOURCE_DIR="`$RPM --eval '%{_sourcedir}'`"
458 SPECS_DIR="`$RPM --eval '%{_specdir}'`"
459
460 __PWD="`pwd`"
00fcec7e 461}
462
d6a77ddb 463get_spec()
1471f6d6 464{
c890b916 465
2e5be021 466 update_shell_title "get_spec"
c890b916 467
cd445739
AM
468 if [ -n "$DEBUG" ]; then
469 set -x;
470 set -v;
471 fi
472
473 cd "$SPECS_DIR"
049ab214 474 if [ ! -f "$SPECFILE" ]; then
cd445739
AM
475 SPECFILE="`basename $SPECFILE .spec`.spec";
476 fi
477 if [ "$NOCVSSPEC" != "yes" ]; then
cd445739 478
049ab214
ER
479 if [ ! -s CVS/Root -a "$NOCVSSPEC" != "yes" ]; then
480 echo "Warning: No CVS access defined - using local .spec file"
481 NOCVSSPEC="yes"
cd445739
AM
482 fi
483
049ab214 484 cvsup "$SPECFILE" || Exit_error err_no_spec_in_repo
cd445739 485 fi
049ab214 486
cd445739
AM
487 if [ ! -f "$SPECFILE" ]; then
488 Exit_error err_no_spec_in_repo;
489 fi
490
491 if [ "$CHMOD" = "yes" -a -n "$SPECFILE" ]; then
492 chmod $CHMOD_MODE $SPECFILE
493 fi
494 unset OPTIONS
a7eefc54 495 [ -n "$DONT_PRINT_REVISION" ] || grep -E -m 1 "^#.*Revision:.*Date" $SPECFILE
7e40520f
ER
496
497 set_spec_target
cd445739
AM
498}
499
500find_mirror()
501{
502 cd "$SPECS_DIR"
503 url="$1"
504 if [ ! -f "mirrors" -a "$NOCVSSPEC" != "yes" ] ; then
505 cvs update mirrors >&2
506 fi
507
508 IFS="|"
509 while read origin mirror name rest
510 do
511 ol=`echo -n "$origin"|wc -c`
512 prefix="`echo -n "$url" | head -c $ol`"
513 if [ "$prefix" = "$origin" ] ; then
514 suffix="`echo "$url"|cut -b $ol-`"
515 echo -n "$mirror$suffix"
516 return 0
517 fi
518 done < mirrors
519 echo "$url"
520}
521
522src_no ()
523{
524 cd $SPECS_DIR
525 rpm_dump | \
526 grep "SOURCEURL[0-9]*[ ]*$1""[ ]*$" | \
527 sed -e 's/.*SOURCEURL\([0-9][0-9]*\).*/\1/' | \
528 head -n 1 | xargs
1471f6d6 529}
530
cd445739 531src_md5 ()
8ba5cdda 532{
cd445739
AM
533 [ X"$NO5" = X"yes" ] && return
534 no=$(src_no "$1")
535 [ -z "$no" ] && return
536 cd $SPECS_DIR
47a8df12 537 spec_rev=$(grep $SPECFILE CVS/Entries 2>/dev/null | sed -e s:/$SPECFILE/:: -e s:/.*::)
cd445739
AM
538 if [ -z "$spec_rev" ]; then
539 spec_rev="$(head -n 1 $SPECFILE | sed -e 's/.*\$Revision: \([0-9.]*\).*/\1/')"
540 fi
541 spec="$SPECFILE[0-9.,]*,$(echo $spec_rev | sed 's/\./\\./g')"
542 md5=$(grep -s -v '^#' additional-md5sums | \
543 grep -E "[ ]$(basename "$1")[ ]+${spec}([ ,]|\$)" | \
544 sed -e 's/^\([0-9a-f]\{32\}\).*/\1/' | \
545 grep -E '^[0-9a-f]{32}$')
546 if [ X"$md5" = X"" ] ; then
6203ea52
AG
547 source_md5=`grep -i "#[ ]*Source$no-md5[ ]*:" $SPECFILE | sed -e 's/.*://'`
548 if [ ! -z "$source_md5" ] ; then
7e365483 549 echo $source_md5;
6203ea52 550 else
7e365483
KK
551 # we have empty SourceX-md5, but it is still possible
552 # that we have NoSourceX-md5 AND NoSource: X
553 nosource_md5=`grep -i "#[ ]*NoSource$no-md5[ ]*:" $SPECFILE | sed -e 's/.*://'`
554 if [ ! -z "$nosource_md5" -a ! X"`grep -i "^NoSource:[ ]*$no$" $SPECFILE`" = X"" ] ; then
555 echo $nosource_md5;
556 fi;
6203ea52 557 fi;
cd445739
AM
558 else
559 if [ $(echo "$md5" | wc -l) != 1 ] ; then
560 echo "$SPECFILE: more then one entry in additional-md5sums for $1" 1>&2
561 fi
562 echo "$md5" | tail -n 1
563 fi
564}
565
566distfiles_url ()
567{
1246dc2a 568 echo "$PROTOCOL$DISTFILES_SERVER/distfiles/by-md5/$(src_md5 "$1" | sed -e 's|^\(.\)\(.\)|\1/\2/&|')/$(basename "$1")"
cd445739
AM
569}
570
571distfiles_attic_url ()
572{
1246dc2a 573 echo "$PROTOCOL$ATTICDISTFILES_SERVER/distfiles/Attic/by-md5/$(src_md5 "$1" | sed -e 's|^\(.\)\(.\)|\1/\2/&|')/$(basename "$1")"
cd445739
AM
574}
575
576good_md5 ()
577{
578 md5=$(src_md5 "$1")
579 [ "$md5" = "" ] || \
580 [ "$md5" = "$(md5sum $(nourl "$1") 2> /dev/null | sed -e 's/ .*//')" ]
8ba5cdda
PG
581}
582
a4b50627
AF
583good_size ()
584{
deccc50e
AM
585 size="$(find $(nourl "$1") -printf "%s" 2>/dev/null)"
586 [ -n "$size" -a "$size" -gt 0 ]
a4b50627
AF
587}
588
947025e5 589cvsignore_df ()
590{
591 if [ "$CVSIGNORE_DF" != "yes" ]; then
592 return
593 fi
594 cvsignore=${SOURCE_DIR}/.cvsignore
595 if ! grep -q "^$1\$" $cvsignore 2> /dev/null; then
596 echo "$1" >> $cvsignore
597 fi
598}
599
e7fa3b9f
ER
600cvsup()
601{
602 update_shell_title "cvsup"
603 local OPTIONS="up "
604 if [ -n "$CVSROOT" ]; then
605 OPTIONS="-d $CVSROOT $OPTIONS"
e7fa3b9f 606 fi
b1c6aace 607
e7fa3b9f
ER
608 if [ -z "$CVSDATE" -a -z "$CVSTAG" ]; then
609 OPTIONS="$OPTIONS -A"
610 else
611 if [ -n "$CVSDATE" ]; then
612 OPTIONS="$OPTIONS -D $CVSDATE"
613 fi
614 if [ -n "$CVSTAG" ]; then
615 OPTIONS="$OPTIONS -r $CVSTAG"
616 fi
617 fi
618
619 local result=1
620 local retries_counter=0
621 update_shell_title "cvsup: $# files"
622 while [ "$result" != "0" -a "$retries_counter" -le "$CVS_RETRIES" ]; do
623 retries_counter=$(( $retries_counter + 1 ))
624 output=$(LC_ALL=C cvs $OPTIONS "$@" 2>&1)
625 result=$?
626 [ -n "$output" ] && echo "$output"
627 if (echo "$output" | grep -qE "(Cannot connect to|connect to .* failed|Connection reset by peer|Connection timed out|Unknown host)") && [ "$result" -ne "0" -a "$retries_counter" -le "$CVS_RETRIES" ]; then
628 echo "Trying again [$*]... ($retries_counter)"
629 update_shell_title "cvsup: retry #$retries_counter"
630 sleep 2
631 continue
632 else
633 break
634 fi
635 done
636 update_shell_title "cvsup: done!"
049ab214 637 return $result
e7fa3b9f
ER
638}
639
cd445739
AM
640get_files()
641{
642 GET_FILES="$@"
af4d5315 643 update_shell_title "fetching sources"
cd445739
AM
644
645 if [ -n "$DEBUG" ]; then
646 set -x;
647 set -v;
648 fi
649
f09c0772 650 if [ $# -gt 0 ]; then
cd445739
AM
651 cd "$SOURCE_DIR"
652
b1c6aace 653 if [ ! -s CVS/Root -a "$NOCVS" != "yes" ]; then
049ab214 654 echo "Warning: No CVS access defined for SOURCES"
b1c6aace
ER
655 NOCVS="yes"
656 fi
657
f2e42a41
ER
658 local nf=$(echo "$GET_FILES" | wc -w)
659 local nc=0
e7fa3b9f 660 local get_files_cvs=""
f09c0772 661 for i in $GET_FILES; do
f2e42a41
ER
662 nc=$((nc + 1))
663 SHELL_TITLE_PREFIX="get_files[$nc/$nf]"
664 update_shell_title "$i"
f09c0772
ER
665 local fp=`nourl "$i"`
666 if [ -f "$fp" ] && [ "$SKIP_EXISTING_FILES" = "yes" ]; then
18e5347d
ER
667 continue
668 fi
cd445739
AM
669 if [ -n "$UPDATE5" ]; then
670 if [ -n "$ADD5" ]; then
f09c0772 671 [ "$fp" = "$i" ] && continue
cd445739
AM
672 grep -qiE '^#[ ]*Source'$(src_no $i)'-md5[ ]*:' $SPECS_DIR/$SPECFILE && continue
673 else
674 grep -qiE '^#[ ]*Source'$(src_no $i)'-md5[ ]*:' $SPECS_DIR/$SPECFILE || continue
675 fi
676 fi
677 FROM_DISTFILES=0
f09c0772 678 if [ ! -f "$fp" ] || [ $ALWAYS_CVSUP = "yes" ]; then
cd445739
AM
679 if echo $i | grep -vE '(http|ftp|https|cvs|svn)://' | grep -qE '\.(gz|bz2)$']; then
680 echo "Warning: no URL given for $i"
681 fi
682
683 if [ -n "$(src_md5 "$i")" ] && [ -z "$NODIST" ]; then
a4b50627 684 if good_md5 "$i" && good_size "$i"; then
deccc50e 685 echo "$(nourl "$i") having proper md5sum already exists"
cd445739
AM
686 continue
687 fi
688 target=$(nourl "$i")
689 url=$(distfiles_url "$i")
690 url_attic=$(distfiles_attic_url "$i")
691 FROM_DISTFILES=1
33da77c4 692 if [ "`echo $url | grep -E '^(\.|/)'`" ]; then
18a52930 693 update_shell_title "${GETLOCAL%% *}: $url"
cd445739
AM
694 ${GETLOCAL} $url $target
695 else
696 if [ -z "$NOMIRRORS" ]; then
697 url="`find_mirror "$url"`"
698 fi
18a52930 699 update_shell_title "${GETURI%% *}: $url"
ca2e6c31 700 ${GETURI} ${OUTFILEOPT} "$target" "$url" || \
33da77c4 701 if [ "`echo $url | grep -E 'ftp://'`" ]; then
18a52930 702 update_shell_title "${GETURI2%% *}: $url"
ca2e6c31 703 ${GETURI2} ${OUTFILEOPT} "$target" "$url"
cd445739
AM
704 fi
705 fi
706 if ! test -s "$target"; then
707 rm -f "$target"
708 if [ `echo $url_attic | grep -E '^(\.|/)'` ]; then
18a52930 709 update_shell_title "${GETLOCAL%% *}: $url_attic"
cd445739
AM
710 ${GETLOCAL} $url_attic $target
711 else
712 if [ -z "$NOMIRRORS" ]; then
713 url_attic="`find_mirror "$url_attic"`"
714 fi
18a52930 715 update_shell_title "${GETURI%% *}: $url_attic"
ca2e6c31 716 ${GETURI} ${OUTFILEOPT} "$target" "$url_attic" || \
33da77c4 717 if [ "`echo $url_attic | grep -E 'ftp://'`" ]; then
18a52930 718 update_shell_title "${GETURI2%% *}: $url_attic"
ca2e6c31 719 ${GETURI2} ${OUTFILEOPT} "$target" "$url_attic"
cd445739
AM
720 fi
721 fi
722 fi
947025e5 723 if test -s "$target"; then
724 cvsignore_df $target
725 else
cd445739
AM
726 rm -f "$target"
727 FROM_DISTFILES=0
728 fi
729 elif [ -z "$(src_md5 "$i")" -a "$NOCVS" != "yes" ]; then
e7fa3b9f
ER
730 get_files_cvs="$get_files_cvs $fp"
731 continue
cd445739
AM
732 fi
733
f09c0772 734 if [ -z "$NOURLS" ] && [ ! -f "$fp" -o -n "$UPDATE" ] && [ "`echo $i | grep -E 'ftp://|http://|https://'`" ]; then
cd445739
AM
735 if [ -z "$NOMIRRORS" ]; then
736 im="`find_mirror "$i"`"
737 else
738 im="$i"
739 fi
18a52930 740 update_shell_title "${GETURI%% *}: $im"
cd445739 741 ${GETURI} "$im" || \
33da77c4 742 if [ "`echo $im | grep -E 'ftp://'`" ]; then
18a52930 743 update_shell_title "${GETURI2%% *}: $im"
cd445739 744 ${GETURI2} "$im"
7e365483 745 fi
cd445739
AM
746 fi
747
748 fi
749 srcno=$(src_no $i)
f09c0772 750 if [ ! -f "$fp" -a "$FAIL_IF_NO_SOURCES" != "no" ]; then
cd445739
AM
751 Exit_error err_no_source_in_repo $i;
752 elif [ -n "$UPDATE5" ] && \
753 ( ( [ -n "$ADD5" ] && echo $i | grep -q -E 'ftp://|http://|https://' && \
754 [ -z "$(grep -E -i '^NoSource[ ]*:[ ]*'$i'([ ]|$)' $SPECS_DIR/$SPECFILE)" ] ) || \
755 grep -q -i -E '^#[ ]*source'$(src_no $i)'-md5[ ]*:' $SPECS_DIR/$SPECFILE )
756 then
deccc50e 757 echo "Updating source-$srcno md5."
f09c0772 758 md5=$(md5sum "$fp" | cut -f1 -d' ')
cd445739 759 perl -i -ne '
deccc50e
AM
760 print unless /^\s*#\s*Source'$srcno'-md5\s*:/i;
761 print "# Source'$srcno'-md5:\t'$md5'\n"
cd445739
AM
762 if /^Source'$srcno'\s*:\s+/;
763 ' \
764 $SPECS_DIR/$SPECFILE
765 fi
2a5f078d 766
a4b50627 767 if good_md5 "$i" && good_size "$i"; then
cd445739
AM
768 :
769 elif [ "$FROM_DISTFILES" = 1 ]; then
deccc50e 770 # wrong md5 from distfiles: remove the file and try again
cd445739 771 # but only once ...
deccc50e 772 echo "MD5 sum mismatch. Trying full fetch."
cd445739
AM
773 FROM_DISTFILES=2
774 rm -f $target
18a52930 775 update_shell_title "${GETURI%% *}: $url"
ca2e6c31 776 ${GETURI} ${OUTFILEOPT} "$target" "$url" || \
33da77c4 777 if [ "`echo $url | grep -E 'ftp://'`" ]; then
18a52930 778 update_shell_title "${GETURI2%% *}: $url"
ca2e6c31 779 ${GETURI2} ${OUTFILEOPT} "$target" "$url"
cd445739
AM
780 fi
781 if ! test -s "$target"; then
782 rm -f "$target"
18a52930 783 update_shell_title "${GETURI%% *}: $url_attic"
ca2e6c31 784 ${GETURI} ${OUTFILEOPT} "$target" "$url_attic" || \
33da77c4 785 if [ "`echo $url_attic | grep -E 'ftp://'`" ]; then
18a52930 786 update_shell_title "${GETURI2%% *}: $url_attic"
ca2e6c31 787 ${GETURI2} ${OUTFILEOPT} "$target" "$url_attic"
cd445739
AM
788 fi
789 fi
790 test -s "$target" || rm -f "$target"
791 fi
792
a4b50627 793 if good_md5 "$i" && good_size "$i" ; then
cd445739
AM
794 :
795 else
deccc50e
AM
796 echo "MD5 sum mismatch or 0 size. Use -U to refetch sources,"
797 echo "or -5 to update md5 sums, if you're sure files are correct."
cd445739
AM
798 Exit_error err_no_source_in_repo $i
799 fi
800 done
e7fa3b9f
ER
801 SHELL_TITLE_PREFIX=""
802
803 if [ "$get_files_cvs" ]; then
804 cvsup $get_files_cvs
805 fi
cd445739
AM
806
807 if [ "$CHMOD" = "yes" ]; then
808 CHMOD_FILES="`nourl $GET_FILES`"
809 if [ -n "$CHMOD_FILES" ]; then
810 chmod $CHMOD_MODE $CHMOD_FILES
811 fi
812 fi
cd445739
AM
813 fi
814}
815
816make_tagver() {
78eab2a1
AM
817
818 if [ -n "$DEBUG" ]; then
819 set -x;
820 set -v;
821 fi
2a5f078d 822
cd445739
AM
823 # Check whether first character of PACKAGE_NAME is legal for tag name
824 if [ -z "${PACKAGE_NAME##[_0-9]*}" -a -z "$TAG_PREFIX" ]; then
825 TAG_PREFIX=tag_
826 fi
827 TAGVER=$TAG_PREFIX$PACKAGE_NAME-`echo $PACKAGE_VERSION | sed -e "s/\./\_/g" -e "s/@/#/g"`-`echo $PACKAGE_RELEASE | sed -e "s/\./\_/g" -e "s/@/#/g"`
828 # Remove #kernel.version_release from TAGVER because tagging sources
829 # could occur with different kernel-headers than kernel-headers used at build time.
830 TAGVER=$(echo "$TAGVER" | sed -e 's/#.*//g')
831 echo -n "$TAGVER"
832}
833
834tag_files()
835{
836 TAG_FILES="$@"
837
838 if [ -n "$DEBUG" ]; then
839 set -x;
840 set -v;
841 fi
842
843 if [ -n "$1$2$3$4$5$6$7$8$9${10}" ]; then
844 echo "Version: $PACKAGE_VERSION"
845 echo "Release: $PACKAGE_RELEASE"
846
847 TAGVER=`make_tagver`
848
849 if [ "$TAG_VERSION" = "yes" ]; then
850 echo "CVS tag: $TAGVER"
851 fi
852 if [ -n "$TAG" ]; then
853 echo "CVS tag: $TAG"
854 fi
855
856 OPTIONS="tag -F"
857 if [ -n "$CVSROOT" ]; then
858 OPTIONS="-d $CVSROOT $OPTIONS"
859 fi
860
861 cd "$SOURCE_DIR"
862 for i in $TAG_FILES
863 do
864 # don't tag files stored on distfiles
865 [ -n "`src_md5 $i`" ] && continue
866 if [ -f "`nourl $i`" ]; then
867 if [ "$TAG_VERSION" = "yes" ]; then
868 cvs $OPTIONS $TAGVER `nourl $i`
869 fi
870 if [ -n "$TAG" ]; then
871 cvs $OPTIONS $TAG `nourl $i`
872 fi
873 else
874 Exit_error err_no_source_in_repo $i
875 fi
876 done
877
878 cd "$SPECS_DIR"
879 if [ "$TAG_VERSION" = "yes" ]; then
880 cvs $OPTIONS $TAGVER $SPECFILE
881 fi
882 if [ -n "$TAG" ]; then
883 cvs $OPTIONS $TAG $SPECFILE
884 fi
885
886 unset OPTIONS
887 fi
888}
889
890branch_files()
891{
892 TAG=$1
893 echo "CVS branch tag: $TAG"
894 shift;
895
896 TAG_FILES="$@"
897
898 if [ -n "$DEBUG" ]; then
899 set -x;
900 set -v;
901 fi
902
903 if [ -n "$1$2$3$4$5$6$7$8$9${10}" ]; then
904
905 OPTIONS="tag -b"
906 if [ -n "$CVSROOT" ]; then
907 OPTIONS="-d $CVSROOT $OPTIONS"
908 fi
909 cd "$SOURCE_DIR"
910 for i in $TAG_FILES
911 do
912 if [ -f `nourl $i` ]; then
913 cvs $OPTIONS $TAG `nourl $i`
914 else
915 Exit_error err_no_source_in_repo $i
916 fi
917 done
918 cd "$SPECS_DIR"
919 cvs $OPTIONS $TAG $SPECFILE
920
921 unset OPTIONS
922 fi
923}
924
925
926
59398507 927build_package()
928{
2e5be021 929 update_shell_title "build_package"
cd445739
AM
930 if [ -n "$DEBUG" ]; then
931 set -x;
932 set -v;
933 fi
5a491465 934
cd445739
AM
935 cd "$SPECS_DIR"
936
937 if [ -n "$TRY_UPGRADE" ]; then
2e5be021 938 update_shell_title "build_package: try_upgrade"
cd445739 939 if [ -n "$FLOAT_VERSION" ]; then
cc538c24 940 TNOTIFY=`./pldnotify.awk $SPECFILE -n` || exit 1
cd445739 941 else
cc538c24 942 TNOTIFY=`./pldnotify.awk $SPECFILE` || exit 1
cd445739
AM
943 fi
944
945 TNEWVER=`echo $TNOTIFY | awk '{ match($4,/\[NEW\]/); print $5 }'`
946
947 if [ -n "$TNEWVER" ]; then
948 TOLDVER=`echo $TNOTIFY | awk '{ print $3; }'`
949 echo "New version found, updating spec file to version " $TNEWVER
950 cp -f $SPECFILE $SPECFILE.bak
951 chmod +w $SPECFILE
952 eval "perl -pi -e 's/Version:\t"$TOLDVER"/Version:\t"$TNEWVER"/gs' $SPECFILE"
f7b91886 953 eval "perl -pi -e 's/Release:\t[1-9]{0,4}/Release:\t0.1/' $SPECFILE"
cd445739 954 parse_spec;
7f347798 955 if [ -n "$ICONS" ]; then
956 get_files $ICONS;
957 parse_spec;
958 fi
f7b91886 959 NODIST="yes" UPDATE5="yes" get_files "$SOURCES $PATCHES";
cd445739
AM
960 unset TOLDVER TNEWVER TNOTIFY
961 fi
962 fi
963 cd "$SPECS_DIR"
2a5f078d 964
cd445739
AM
965 case "$COMMAND" in
966 build )
967 BUILD_SWITCH="-ba" ;;
968 build-binary )
969 BUILD_SWITCH="-bb" ;;
970 build-source )
971 BUILD_SWITCH="-bs --nodeps" ;;
972 build-prep )
973 BUILD_SWITCH="-bp --nodeps" ;;
974 esac
c890b916 975
2e5be021 976 update_shell_title "build_package: $COMMAND"
cd445739
AM
977 if [ -n "$LOGFILE" ]; then
978 LOG=`eval echo $LOGFILE`
979 if [ -d "$LOG" ]; then
980 echo "Log file $LOG is a directory."
981 echo "Parse error in the spec?"
982 Exit_error err_build_fail;
983 fi
984 if [ -n "$LASTLOG_FILE" ]; then
985 echo "LASTLOG=$LOG" > $LASTLOG_FILE
986 fi
987 RES_FILE=~/tmp/$RPMBUILD-exit-status.$RANDOM
21bc1a97 988 (time eval nice -n ${DEF_NICE_LEVEL} $RPMBUILD $BUILD_SWITCH -v $QUIET $CLEAN $RPMOPTS $BCOND $TARGET_SWITCH $SPECFILE; echo $? > $RES_FILE) 2>&1 |tee $LOG
cd445739
AM
989 RETVAL=`cat $RES_FILE`
990 rm $RES_FILE
991 if [ -n "$LOGDIROK" ] && [ -n "$LOGDIRFAIL" ]; then
992 if [ "$RETVAL" -eq "0" ]; then
993 mv $LOG $LOGDIROK
994 else
995 mv $LOG $LOGDIRFAIL
996 fi
997 fi
8ba5cdda 998 else
8f96ab6c 999 eval nice -n ${DEF_NICE_LEVEL} $RPMBUILD $BUILD_SWITCH -v $QUIET $CLEAN $RPMOPTS $BCOND $TARGET_SWITCH $SPECFILE
cd445739 1000 RETVAL=$?
8ba5cdda 1001 fi
cd445739
AM
1002 if [ "$RETVAL" -ne "0" ]; then
1003 if [ -n "$TRY_UPGRADE" ]; then
1004 echo "\n!!! Package with new version cannot be build automagically\n"
1005 mv -f $SPECFILE.bak $SPECFILE
1006 fi
1007 Exit_error err_build_fail;
1008 fi
1009 unset BUILD_SWITCH
1010}
1011
1012nourl()
1013{
1014 echo "$@" | sed 's#\<\(ftp\|http\|https\|cvs\|svn\)://[^ ]*/##g'
1015}
1016
cd445739
AM
1017install_required_packages()
1018{
1019 run_poldek -vi $1
1020 return $?
1021}
1022
1023set_bconds_values()
1024{
0b65d15e 1025 update_shell_title "set bcond values"
c890b916 1026
cd445739
AM
1027 AVAIL_BCONDS_WITHOUT=""
1028 AVAIL_BCONDS_WITH=""
1029 if `grep -q ^%bcond ${SPECFILE}`; then
1030 BCOND_VERSION="NEW"
36d03934 1031 elif `egrep -q ^#\ *_with ${SPECFILE}`; then
cd445739
AM
1032 BCOND_VERSION="OLD"
1033 else
1034 BCOND_VERSION="NONE"
1035 fi
301cbfd4
ER
1036
1037 # expand bconds from ~/.bcondrc
1038 # The file structure is like gentoo's package.use:
1039 # ---
1040 # * -selinux
1041 # samba -mysql -pgsql
47a8df12 1042 # w32codec-installer license_agreement
301cbfd4
ER
1043 # php +mysqli
1044 # ---
c8a3e2ac 1045 if [ "${BCOND_VERSION}" != "NONE" ] && ( [ -f $HOME/.bcondrc ] || ( [ -n $HOME_ETC ] && [ -f $HOME_ETC/.bcondrc ] ) ) ; then
301cbfd4
ER
1046 # This takes package name, first defined in spec.
1047 # so consider that when defining flags for package.
1048 PN=`$RPM -q --qf '%{NAME}\n' --specfile $SPECFILE | head -n 1`
3e1cbfe0 1049 SN=${SPECFILE%%\.spec}
301cbfd4
ER
1050 AVAIL=`$RPMBUILD --bcond $SPECFILE`
1051
c8a3e2ac
AG
1052 BCONDRC=$HOME/.bcondrc
1053 [ -n $HOME_ETC ] && [ -f $HOME_ETC/.bcondrc ] && BCONDRC=$HOME_ETC/.bcondrc
1054
301cbfd4
ER
1055 while read pkg flags; do
1056 # ignore comments
1057 [[ "$pkg" == \#* ]] && continue
1058
1059 # any package or current package?
3e1cbfe0 1060 if [ "$pkg" = "*" ] || [ "$pkg" = "$PN" ] || [ "$pkg" = "$SN" ]; then
301cbfd4
ER
1061 for flag in $flags; do
1062 opt=${flag#[+-]}
1063
1064 # use only flags which are in this package.
1065 if [[ $AVAIL = *${opt}* ]]; then
3b5101f0
ER
1066 if [[ $flag = -* ]]; then
1067 BCOND="$BCOND --without $opt"
301cbfd4 1068 else
3b5101f0 1069 BCOND="$BCOND --with $opt"
301cbfd4
ER
1070 fi
1071 fi
1072 done
1073 fi
c8a3e2ac 1074 done < $BCONDRC
301cbfd4
ER
1075 fi
1076
cd445739
AM
1077 case "${BCOND_VERSION}" in
1078 NONE)
7e365483 1079 :
cd445739 1080 ;;
7e365483 1081 OLD)
cd445739
AM
1082 echo "Warning: This spec has old style bconds. Fix it || die."
1083 for opt in `$RPMBUILD --bcond $SPECFILE |grep ^_without_`
1084 do
1085 AVAIL_BCOND_WITHOUT=`echo $opt|sed -e "s/^_without_//g"`
1086 if `echo $BCOND|grep -q -- "--without $AVAIL_BCOND_WITHOUT"`;then
1087 AVAIL_BCONDS_WITHOUT="$AVAIL_BCONDS_WITHOUT <$AVAIL_BCOND_WITHOUT>"
1088 else
1089 AVAIL_BCONDS_WITHOUT="$AVAIL_BCONDS_WITHOUT $AVAIL_BCOND_WITHOUT"
1090 fi
1091 done
2a5f078d 1092
cd445739
AM
1093 for opt in `$RPMBUILD --bcond $SPECFILE |grep ^_with_`
1094 do
1095 AVAIL_BCOND_WITH=`echo $opt|sed -e "s/^_with_//g"`
1096 if `echo $BCOND|grep -q -- "--with $AVAIL_BCOND_WITH"`;then
1097 AVAIL_BCONDS_WITH="$AVAIL_BCONDS_WITH <$AVAIL_BCOND_WITH>"
1098 else
1099 AVAIL_BCONDS_WITH="$AVAIL_BCONDS_WITH $AVAIL_BCOND_WITH"
1100 fi
1101 done
1102 ;;
1103 NEW)
1104 cond_type="" # with || without
1105 for opt in `$RPMBUILD --bcond $SPECFILE`
1106 do
1107 case "$opt" in
1108 _without)
1109 cond_type="without"
1110 ;;
1111 _with)
1112 cond_type="with"
1113 ;;
f8d24cee 1114 _without_*)
1115 AVAIL_BCOND_WITHOUT="`echo $opt | sed 's/^_without_//g'`"
1116 if `echo $BCOND|grep -q -- "--without $AVAIL_BCOND_WITHOUT"`;then
1117 AVAIL_BCONDS_WITHOUT="$AVAIL_BCONDS_WITHOUT <$AVAIL_BCOND_WITHOUT>"
1118 else
1119 AVAIL_BCONDS_WITHOUT="$AVAIL_BCONDS_WITHOUT $AVAIL_BCOND_WITHOUT"
1120 fi
1121 ;;
1122 _with_*)
1123 AVAIL_BCOND_WITH="`echo $opt | sed 's/^_with_//g'`"
1124 if `echo $BCOND|grep -q -- "--with $AVAIL_BCOND_WITH"`;then
1125 AVAIL_BCONDS_WITH="$AVAIL_BCONDS_WITH <$AVAIL_BCOND_WITH>"
1126 else
1127 AVAIL_BCONDS_WITH="$AVAIL_BCONDS_WITH $AVAIL_BCOND_WITH"
1128 fi
1129 ;;
cd445739
AM
1130 *)
1131 case "$cond_type" in
1132 with)
1133 cond_type=''
1134 AVAIL_BCOND_WITH="$opt"
1135 if `echo $BCOND|grep -q -- "--with $AVAIL_BCOND_WITH"`;then
1136 AVAIL_BCONDS_WITH="$AVAIL_BCONDS_WITH <$AVAIL_BCOND_WITH>"
1137 else
1138 AVAIL_BCONDS_WITH="$AVAIL_BCONDS_WITH $AVAIL_BCOND_WITH"
1139 fi
7e365483 1140 ;;
cd445739
AM
1141 without)
1142 cond_type=''
1143 AVAIL_BCOND_WITHOUT="$opt"
1144 if `echo $BCOND|grep -q -- "--without $AVAIL_BCOND_WITHOUT"`;then
1145 AVAIL_BCONDS_WITHOUT="$AVAIL_BCONDS_WITHOUT <$AVAIL_BCOND_WITHOUT>"
1146 else
1147 AVAIL_BCONDS_WITHOUT="$AVAIL_BCONDS_WITHOUT $AVAIL_BCOND_WITHOUT"
1148 fi
1149 ;;
1150 esac
1151 ;;
1152 esac
1153 done
1154 ;;
1155 esac
1156}
1157
1158run_sub_builder()
1159{
1160 package_name="${1}"
af6b168f 1161 update_shell_title "run_sub_builder $package_name"
cd445739
AM
1162 #
1163